// PS2 Keyboard test

#include <18F4553.h>
#fuses HS,NOWDT,NOPROTECT,NOLVP,NODEBUG,USBDIV,PLL5,CPUDIV1,VREGEN
#use delay(clock=20000000,oscillator)
//#use fast_io(B)

#include <STDLIB.H>
#include <lcd.c>

#include <PS2Key.h>
#include <PS2ScanCode.h>
#include <PS2Key.c>

INT8U PS2Key_Char;

#int_EXT2
void ext_isr(void)
{
	PS2KeyIntHandler();
}

void main(void)
{
	int cnt=0;
	
	port_b_pullups(TRUE);
	setup_adc_ports(NO_ANALOGS);

    lcd_init();					//Init LCD module
	lcd_putc('\f');
	
	PS2KeyInit();				//Init PS2 Keyboard

	enable_interrupts(global);	//enable global interrupts

	for(;;)
	{
		if(PS2KeyHit()){
			
			PS2Key_Char = PS2KeyGetKey();
			lcd_putc(PS2KeyDecode(PS2Key_Char) );
			if (cnt++ > 15) {
				lcd_putc('\f');
				cnt=0;
			}	
			
			// some tests
			
			// switch on NUM, CAPS, SCROLL, 
			if (PS2KeyUnshifted[PS2Key_Char]=='a') {
				PS2SendComm(0xED);
				PS2SendComm(0x1);
			}
			
			// switch off NUM, CAPS, SCROLL, 
			if (PS2KeyUnshifted[PS2Key_Char]=='s') {
				PS2SendComm(0xED);
				PS2SendComm(0x0);
			}

			//
			if (PS2KeyUnshifted[PS2Key_Char]=='e') {
				;
			}

			if (PS2KeyUnshifted[PS2Key_Char]=='t') {
				if (PS2TestKeyboard()) 	printf(lcd_putc, "\fPS2 Keyboard gefunden");
				else  	printf(lcd_putc, "\fPS2 Keyboard nicht gefunden");
			}
			//*/
			
		}
	}
}
